=== debian/changelog ===
postler (0.1.1-1ubuntu1) oneiric; urgency=low

  * debian/control: Bump libindicate-dev version to 0.5.90
  * debian/patches/01_indicate_0.6.patch: Fix FTBFS with indicate 0.6

 -- Laurent Bigonville <bigon@ubuntu.com>  Mon, 05 Sep 2011 11:23:57 +0200

postler (0.1.1-1build1) oneiric; urgency=low

  * No change rebuild for libnotify1 -> libnotify4 transition 

 -- Micah Gersten <micahg@ubuntu.com>  Sun, 07 Aug 2011 01:50:51 -0500

postler (0.1.1-1) unstable; urgency=low

  * New upstream release.
  * Remove 00-libindicate5.diff and 01-vala_0_10_4.diff patches, fixed
    upstream.
  * Add debian/watch file.
  * Bump Standards-Version to 3.9.2.

 -- Devid Antonio Filoni <d.filoni@ubuntu.com>  Mon, 09 May 2011 21:51:18 +0200

postler (0.1.0-1) unstable; urgency=low

  * Initial release (Closes: #615878).

 -- Devid Antonio Filoni <d.filoni@ubuntu.com>  Fri, 15 Apr 2011 23:37:32 +0200
