=== debian/control ===
Source: postler
Section: mail
Priority: optional
Maintainer: Devid Antonio Filoni <d.filoni@ubuntu.com>
Build-Depends: debhelper (>= 7.0.50~), python (>= 2.4), valac-0.10 (>= 0.10.4),
 libglib2.0-dev (>= 2.26.0), libunique-dev (>= 1.0.4), libgtk2.0-dev
 (>= 2.18.0), libwebkit-dev (>= 1.1.18), libnotify-dev, libcanberra-dev,
 libindicate-dev (>= 0.5.90), libssl-dev, intltool, libdb4.8-dev, msmtp
Standards-Version: 3.9.2
Homepage: https://launchpad.net/postler

Package: postler
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, msmtp
Description: desktop mail client built in vala
 Postler is a super sexy, ultra simple desktop mail client built in vala. It
 aims to be easy, simple, clean, beautiful, and automagic.
 .
 It handles IMAP beautifully, and provides the user with smart, sensible
 defaults.
