=== debian/watch ===
version=3
http://git.xfce.org/apps/postler \
  /apps/postler/snapshot/postler-(.+)\.tar\.bz2
